#ifndef GLWINDOW_H
#define GLWINDOW_H

class QOpenGLShaderProgram;

#include <QtGui/QWindow>
#include <QtGui/QOpenGLFunctions>

class GLWindow : public QWindow, protected QOpenGLFunctions
{
public:
    explicit GLWindow(QWindow *parent = 0);
    
private:
    QOpenGLShaderProgram * m_program;
    QOpenGLContext * m_context;

    GLuint m_posAttr;
    GLuint m_colAttr;
    GLuint m_matrixUniform;

    void exposeEvent(QExposeEvent *event);
    void resizeEvent(QResizeEvent *event);

    /* Inizializziamo l'ambiente opengl */
    virtual void initialize();
    /* Inizializzazione shaders */
    virtual void initShaders();
    /* Disegna l'oggetto */
    virtual void paint();
    /* Istruzioni opengl per disegnare gli oggetti */
    virtual void paintGL();
};

#endif // GLWINDOW_H
